From 05b480c3f5eb8e4762c57091ac8a2bb7532bd2e3 Mon Sep 17 00:00:00 2001
From: Aurélien Bompard <aurelien@bompard.org>
Date: Feb 09 2017 15:58:10 +0000
Subject: [PATCH 713/1001] Convert the badges widget


---

diff --git a/hubs/tests/test_widgets/test_badges.py b/hubs/tests/test_widgets/test_badges.py
index 8a88807..f8ae5b6 100644
--- a/hubs/tests/test_widgets/test_badges.py
+++ b/hubs/tests/test_widgets/test_badges.py
@@ -22,7 +22,8 @@ class TestBadges(hubs.tests.test_widgets.WidgetTest):
         # msg = self.get_fedmsg('2016-ebb84660-59e9-4e68-af8f-4e6f49348b88')
         msg = {'topic': 'hubs.widget.update.WRONG.TOPIC'}
         module = hubs.widgets.registry[widget.plugin]
-        result = module.should_invalidate(msg, self.session, widget)
+        func = module.get_cached_functions()['GetBadges']
+        result = func(widget).should_invalidate(msg)
         self.assertFalse(result)
 
     def test_should_invalidate_wrong_user(self):
@@ -30,7 +31,8 @@ class TestBadges(hubs.tests.test_widgets.WidgetTest):
         # msg = self.get_fedmsg('2016-e371c7f6-bc8e-4632-8e33-b9102dc30b5f')
         msg = {'topic': 'fedbadges.badge.award', 'msg': {'user': {'username': 'not_ralph'}}}
         module = hubs.widgets.registry[widget.plugin]
-        result = module.should_invalidate(msg, self.session, widget)
+        func = module.get_cached_functions()['GetBadges']
+        result = func(widget).should_invalidate(msg)
         self.assertFalse(result)
 
     def test_should_invalidate_good_match_fedbadges(self):
@@ -38,7 +40,8 @@ class TestBadges(hubs.tests.test_widgets.WidgetTest):
         # msg = self.get_fedmsg('2016-1fbb1135-681b-4d3b-9a40-d0f6ebd313f4')
         msg = {'topic': 'fedbadges.badge.award', 'msg': {'user': {'username': 'ralph'}}}
         module = hubs.widgets.registry[widget.plugin]
-        result = module.should_invalidate(msg, self.session, widget)
+        func = module.get_cached_functions()['GetBadges']
+        result = func(widget).should_invalidate(msg)
         self.assertTrue(result)
 
     def test_should_invalidate_good_match_hubswidget(self):
@@ -46,5 +49,6 @@ class TestBadges(hubs.tests.test_widgets.WidgetTest):
         # msg = self.get_fedmsg('2016-1fbb1135-681b-4d3b-9a40-d0f6ebd313f4')
         msg = {'topic': 'hubs.widget.update', 'msg': {'widget': {'id': widget.idx + 1}}}
         module = hubs.widgets.registry[widget.plugin]
-        result = module.should_invalidate(msg, self.session, widget)
+        func = module.get_cached_functions()['GetBadges']
+        result = func(widget).should_invalidate(msg)
         self.assertTrue(result)
diff --git a/hubs/widgets/badges/__init__.py b/hubs/widgets/badges/__init__.py
new file mode 100644
index 0000000..a6d838f
--- /dev/null
+++ b/hubs/widgets/badges/__init__.py
@@ -0,0 +1,56 @@
+from __future__ import unicode_literals
+
+import operator
+import requests
+
+from hubs import validators
+from hubs.widgets.base import Widget, WidgetView
+from hubs.widgets.caching import CachedFunction
+from hubs.widgets.chrome import panel
+
+
+class Badges(Widget):
+
+    name = "badges"
+    position = "right"
+    arguments = [dict(
+        name="username",
+        label="Username",
+        default=None,
+        validator=validators.username,
+        help="A FAS username.",
+        )]
+
+
+class BaseView(WidgetView):
+
+    name = "root"
+    url_rules = ["/"]
+    template_name = "templates/badges.html"
+    chrome = panel("Badges")
+
+    def get_context(self, instance, *args, **kwargs):
+        get_badges = GetBadges(instance)
+        return get_badges()
+
+
+class GetBadges(CachedFunction):
+
+    def execute(self):
+        username = self.instance.config["username"]
+        url = "https://badges.fedoraproject.org/user/{username}/json"
+        url = url.format(username=username)
+        response = requests.get(url)
+        assertions = response.json()['assertions']
+        key = operator.itemgetter('issued')
+        return dict(assertions=sorted(assertions, key=key, reverse=True))
+
+    def should_invalidate(self, message):
+        if message['topic'].endswith('hubs.widget.update'):
+            if message['msg']['widget']['id'] != self.instance.idx:
+                return True
+        if message['topic'].endswith('fedbadges.badge.award'):
+            username = self.instance.config['username']
+            if message['msg']['user']['username'] == username:
+                return True
+        return False

